unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeTree, ExtCtrls, TeeProcs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    Tree1: TTree;
    procedure Tree1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Tree1Click(Sender: TObject);
    procedure Tree1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Tree1SelectShape(Sender: TTreeNodeShape);
    procedure Tree1EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Tree1DblClick(Sender: TObject);
    procedure Tree1DblClickShape(Sender: TTreeNodeShape; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Tree1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Tree1DragDropShape(Sender: TCustomTree; Dragged,
      Parent: TTreeNodeShape);
    procedure Tree1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Tree1UnSelectShape(Sender: TTreeNodeShape);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var I: Integer;
begin
   for I := 0 To 99 Do
   begin
      Tree1.AddRoot('Node ' + IntToStr(I));
   end;

   Tree1.DragAndDrop.Automatic:=true;
   RichEdit1.Clear;
   RichEdit1.ScrollBars:=ssVertical;
end;

procedure TForm1.Tree1Click(Sender: TObject);
begin
  RichEdit1.Lines.Add('Click');
end;

procedure TForm1.Tree1DblClick(Sender: TObject);
begin
  RichEdit1.Lines.Add('DoubleClick');
end;

procedure TForm1.Tree1DblClickShape(Sender: TTreeNodeShape;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  RichEdit1.Lines.Add('DoubleClickShape');
end;

procedure TForm1.Tree1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  RichEdit1.Lines.Add('DragDrop');
end;

procedure TForm1.Tree1DragDropShape(Sender: TCustomTree; Dragged,
  Parent: TTreeNodeShape);
begin
  RichEdit1.Lines.Add('DragDropShape');
end;

procedure TForm1.Tree1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  RichEdit1.Lines.Add('DragOver');
end;

procedure TForm1.Tree1EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  RichEdit1.Lines.Add('EndDrag');
end;

procedure TForm1.Tree1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RichEdit1.Lines.Add('MouseDown');
end;

procedure TForm1.Tree1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  RichEdit1.Lines.Add('MouseUp');
end;

procedure TForm1.Tree1SelectShape(Sender: TTreeNodeShape);
begin
  RichEdit1.Lines.Add('SelectShape');
end;

procedure TForm1.Tree1UnSelectShape(Sender: TTreeNodeShape);
begin
  RichEdit1.Lines.Add('UnselectShape');
end;

end.
